﻿/*

-------------------------------------------------------------------

AD TWEEN
Classed from tween prototype

Usage:

var poopClip = new zmcTween(myClipToTween);
poopClip.slideTo(100,100,5,’easeoutexpo’, yada yada yada);

-------------------------------------------------------------------

*/

class adTween {
	
	private var clip:MovieClip;
	
	public function adTween (mcRef:MovieClip){
		clip = mcRef;
	};
	

	function tween (prop, propDest, timeSeconds, animType, delay, callback, extra1, extra2){
		// Sets default values if undefined/invalid
		if (timeSeconds < 0.001) timeSeconds =.5;
		// default time length
		if (animType == undefined || animType == "") animType = "easeOutExpo";
		// default equation!
		if (delay == undefined) delay = 0;
		// default delay
		// Starts tweening.. prepares to create handling mcs
		if (typeof (prop) == "string")
		{
			// Single property
			var properties = [prop];
			// Properties, as in "_x"
			var oldProperties = [clip [prop]];
			// Old value, as in 0
			var newProperties = [propDest];
			// New (target) value, as in 100
			
		} else 
		{
			// Array of properties
			var properties = [];
			// Properties, as in "_x"
			var oldProperties = [];
			// Old value, as in 0
			var newProperties = [];
			// New (target) value, as in 100
			for (var i in prop) oldProperties.push (clip [prop [i]]); 
			for (var i in prop) properties.push (prop [i]); 
			for (var i in propDest) newProperties.push (propDest [i]); 
		}
		var $_callback_assigned = false;
		// 1.7.4: Knows if callback has already been assigned to a movieclip
		// Checks if the master movieClip (which controls all tweens) exists
		if (_root.__tweenController__ == undefined)
		{
			// Doesn't exist: create, and set its methods/data
			var tweenHolder = _root.createEmptyMovieClip ("__tweenController__", 123432);
			// Any level
			tweenHolder.$_tweenPropList = new Array ();
			// Nick : create reference to class
			tweenHolder.classRef = this;
			// Will hold the list of properties beeing tweened. an array of objects.
			tweenHolder.onEnterFrame = function ()
			{
				// On each pass, it should check and update the properties
				var tTime = getTimer ();
				for (var i = 0; i < this.$_tweenPropList.length; i ++)
				{
					var objProp = this.$_tweenPropList [i];
					// Temporary shortcut to this property controller object
					if (objProp._timeStart + (objProp._delay * 1000) <= tTime)
					{
						// Starts tweening already
						if (objProp._timeDest + (objProp._delay * 1000) <= tTime)
						{
							// Past the destiny time: ended.
							// Set it to its final value to make sure
							// there are no discrepancies
							objProp._targ [objProp._prop] = objProp._propDest;
							// Removes from the tweening properties list array. So simpler than the previous versions :)
							// (objProp still exists so it works further on)
							this.$_tweenPropList.splice (i, 1);
							i --;
							objProp._targ.$_tweenCount --;
							if (objProp._targ.$_tweenCount == 0) delete objProp._targ.$_tweenCount;
							if (objProp._callback != undefined)
							{
								// Calls the _callback function
								if (_global.backwardCallbackTweening)
								{
									// Old style, for compatibility.
									// IF YOU'RE USING AN OLD VERSION AND WANT BACKWARD COMPATIBILITY, use this line:
									// _global.backwardCallbackTweening = true;
									// ON YOUR MOVIES AFTER (or before) THE #INCLUDE STATEMENT.
									var childMC = objProp._targ.createEmptyMovieClip ("__child__", 122344);
									objProp._callback.apply (childMC, null);
									childMC.removeMovieClip ();
								} else 
								{
									// New method for 2.12.9: use the mc scope
									// So simpler. I should have done this from the start...
									// ...instead of trying the impossible (using the scope from which the tween was called)
									objProp._callback.apply (objProp._targ, null);
								}
							}
							// Deletes the tweener movieclip if no tweens are left
							if (this.$_tweenPropList.length == 0) this.removeMovieClip ();
						} else 
						{
							// Continue, simply set the correct property value.
							if (objProp._propStart == undefined) objProp._propStart = objProp._targ [objProp._prop];
							// "first-time" update to allow dinamically changed values for delays (2.14.9)
							objProp._targ [objProp._prop] = this.classRef.findTweenValue (objProp._propStart, objProp._propDest, objProp._timeStart, tTime - (objProp._delay * 1000) , objProp._timeDest, objProp._animType, objProp._extra1, objProp._extra2);
							if (typeof (objProp._targ) != "movieclip" && (objProp._prop == "__special_text_b__"))
							{
								// Special case: textfield, B value for textColor value. B being the last one to update, so also set the textfield's textColor
								objProp._targ.textColor = (objProp._targ.__special_text_r__ << 16) + (objProp._targ.__special_text_g__ << 8) + objProp._targ.__special_text_b__;
							}
						}
					}
				}
			};
		}
		var tweenPropList = _root.__tweenController__.$_tweenPropList;
		// Now set its data (adds to the list of properties being tweened)
		var tTime = getTimer ();
		// fix on 2.13.9 for a more uniform time (uses the exactly same time on different properties)
		for (var i in oldProperties)
		{
			// Set one new object for each property that should be tweened
			if (newProperties [i] != undefined && ! clip.$_isTweenLocked)
			{
				// Only creates tweenings for properties that are not undefined. That way,
				// certain properties can be optional on the shortcut functions even though
				// they are passed to the tweening function
				// Checks if it's at the tween list already
				if (clip.$_tweenCount > 0)
				{
					for (var pti = 0; pti < tweenPropList.length; pti ++)
					{
						if (tweenPropList [pti]._targ == clip && tweenPropList [pti]._prop == properties [i])
						{
							// Exists for the same property... checks if the time is the same (if the NEW's start time would be before the OLD's ending time)
							if (tTime + (delay * 1000) < tweenPropList [pti]._timeDest)
							{
								// It's a property that is already being tweened, BUT has already started, so it's ok to overwrite.
								// So it deletes the old one(s) and THEN creates the new one.
								tweenPropList.splice (pti, 1);
								pti --;
								clip.$_tweenCount --;
							}
						}
					}
				}
				// Finally, adds the new tween data to the list
				tweenPropList.push (
				{
					_prop : properties [i] ,
					_targ : clip,
					_propStart : undefined, // was "oldProperties[i]" (2.14.9). Doesn't set: it must be read at the first update time, to allow animating with correct [new] values when using the delay parameter
					_propDest : newProperties [i] ,
					_timeStart : tTime,
					_timeDest : tTime + (timeSeconds * 1000) ,
					_animType : animType,
					_extra1 : extra1,
					_extra2 : extra2,
					_delay : delay,
					_callback : $_callback_assigned ? undefined : callback
				});
				// $tweenCount is used for a faster start
				clip.$_tweenCount = clip.$_tweenCount > 0 ? clip.$_tweenCount + 1 : 1;
				// to avoid setting ++ to undefined
				$_callback_assigned = true;
				// 1.7.4
				
			}
		}
		// Hides stuff from public view on the movieclip being tweened
		//ASSetPropFlags (clip, "$_tweenCount", 1, 0);
		// List of stuff being tweened
		
	};
	
	//
	//ASSetPropFlags (MovieClip.prototype, "tween", 1, 0);
	
	function lockTween ()
	{
		clip.$_isTweenLocked = true;
		//ASSetPropFlags (this, "this.$_isTweenLocked", 1, 0);
	};
	
	//
	//ASSetPropFlags (MovieClip.prototype, "lockTween", 1, 0);

	
	function unlockTween ()
	{
		delete (clip.$_isTweenLocked);
	};
	
	//
	//ASSetPropFlags (MovieClip.prototype, "unlockTween", 1, 0);
	
	function getTweens ()
	{
		// Returns the number of tweenings actually being executed
		// Tweenings are NOT overwritten, so it's possible to have a series of tweenings at the same time
		return (clip.$_tweenCount);
	};
	
	//ASSetPropFlags (MovieClip.prototype, "getTweens", 1, 0);
	
	
	function isTweening()
	{
		// Returns true if there's at least one tweening being executed, otherwise false
		return (clip.$_tweenCount > 0 ? true : false);
	};
	
	//ASSetPropFlags (MovieClip.prototype, "isTweening", 1, 0);
	
	function stopTween (props)
	{
		// Removes tweenings immediately, leaving objects as-is. Examples:
		//  <movieclip>.stopTween ("_x");          // Stops _x tweening
		//  <movieclip>.stopTween (["_x", "_y"]);  // Stops _x and _y tweening
		//  <movieclip>.stopTween ();              // Stops all tweening processes
		var tweenPropList = _root.__tweenController__.$_tweenPropList;
		switch (typeof (props))
		{
			case "string" : // one property. example: "_alpha"
			props = [props];
			case "object" : // several properties. example: ["_alpha", "_rotation"]
			for (var i in props)
			{
				for (var pti in tweenPropList)
				{
					if (tweenPropList [pti]._targ == clip && tweenPropList [pti]._prop == props [i])
					{
						tweenPropList.splice (pti, 1);
					}
				}
			}
			// Updates the tween count "cache"
			clip.$_tweenCount = 0;
			for (var pti in tweenPropList)
			{
				if (tweenPropList [pti]._targ == clip) clip.$_tweenCount ++;
			}
			if (clip.$_tweenCount == 0) delete (clip.$_tweenCount);
			break;
			default : // empty. deletes/stops everything *for this movieclip*
			for (var pti in tweenPropList)
			{
				if (tweenPropList [pti]._targ == clip) tweenPropList.splice (pti, 1);
			}
			delete (clip.$_tweenCount);
		}
		if (tweenPropList.length == 0)
		{
			// No tweenings remain, remove it
			_root.__tweenController__.removeMovieClip ();
			clip.__tweenController_ADVhelper__.removeMovieClip ();
		}
	};
	
	
	function scaleTo (propDest_scale, timeSeconds, animType, delay, callback, extra1, extra2)
	{
		// Scales an object uniformly. Example: <movieclip>.scaleTo(200)
		tween (["_xscale", "_yscale"] , [propDest_scale, propDest_scale] , timeSeconds, animType, delay, callback, extra1, extra2);
	};
	
	function slideTo (propDest_x, propDest_y, timeSeconds, animType, delay, callback, extra1, extra2)
	{
		// Does a xy sliding tween. Example: <movieclip>.slideTo(100, 100)
		tween (["_x", "_y"] , [propDest_x, propDest_y] , timeSeconds, animType, delay, callback, extra1, extra2);
	};
	
	function findTweenValue (_propStart, _propDest, _timeStart, _timeNow, _timeDest, _animType, _extra1, _extra2):Number {
		var t = _timeNow - _timeStart;
		// current time (frames, seconds)
		var b = _propStart;
		// beginning value
		var c = _propDest - _propStart;
		// change in value
		var d = _timeDest - _timeStart;
		// duration (frames, seconds)
		var a = _extra1;
		// amplitude (optional - used only on *elastic easing)
		var p = _extra2;
		// period (optional - used only on *elastic easing)
		var s = _extra1;
		// overshoot ammount (optional - used only on *back easing)
		switch (_animType.toLowerCase ())
		{
			
			case "easeoutexpo" :
			// exponential (2^t) easing out - decelerating to zero velocity
			return (t == d) ? b + c : c * ( - Math.pow (2, - 10 * t / d) + 1) + b;
			
			case "easeoutquad" :
			
			return -c *(t/=d)*(t-2) + b;
			
			case "easeinoutquad" :
			if ((t/=d/2) < 1) return c/2*t*t + b;
			return -c/2 * ((--t)*(t-2) - 1) + b;
			
			case "easeoutelastic" :
			// Nick
			if (a == undefined) a = 0;
			// elastic (exponentially decaying sine wave)
			if (t == 0) return b;
			if ((t /= d) == 1) return b + c;
			if ( ! p) p = d *.3;
			if (a < Math.abs (c))
			{
				a = c;
				var s = p / 4;
				
			} 
			else var s = p / (2 * Math.PI) * Math.asin (c / a);
			return a * Math.pow (2, - 10 * t) * Math.sin ((t * d - s) * (2 * Math.PI) / p ) + c + b;
			
			case "linear" :
			// simple linear tweening - no easing
			return c * t / d + b;
			
			case "easeinexpo" :
			// exponential (2^t) easing in - accelerating from zero velocity
			return (t == 0) ? b : c * Math.pow (2, 10 * (t / d - 1)) + b;
			
			case "easeinbounce" :
			// bounce (exponentially decaying parabolic bounce) easing in
			return c - findTweenValue (0, c, 0, d - t, d, "easeOutBounce") + b;
			
			case "easeoutbounce" :
			// bounce (exponentially decaying parabolic bounce) easing out
			if ((t /= d) < (1 / 2.75))
			{
				return c * (7.5625 * t * t) + b;
			} else if (t < (2 / 2.75))
			{
				return c * (7.5625 * (t -= (1.5 / 2.75)) * t +.75) + b;
			} else if (t < (2.5 / 2.75))
			{
				return c * (7.5625 * (t -= (2.25 / 2.75)) * t +.9375) + b;
			} else 
			{
				return c * (7.5625 * (t -= (2.625 / 2.75)) * t +.984375) + b;
			}
		}
	};
	//ASSetPropFlags (clip, "findTweenValue", 1, 0);
	
	/*
	function colorTo (propDest_color, timeSeconds, animType, delay, callback, extra1, extra2)
	{
		// Does a simple color transformation (tint) tweening.
		// Works like Flash MX's color.setRGB method.
		//  Example: <movieclip>.colorTo(0xFF6CD9)
		var new_r = propDest_color >> 16;
		var new_g = (propDest_color & 0x00FF00) >> 8;
		var new_b = propDest_color & 0x0000FF;
		// Normal movieclip, so create a colorTransformTo tween
		this.colorTransformTo (0, new_r, 0, new_g, 0, new_b, undefined, undefined, timeSeconds, animType, delay, callback, extra1, extra2);
		
	};
	
	function colorTransformTo (propDest_ra, propDest_rb, propDest_ga, propDest_gb, propDest_ba, propDest_bb, propDest_aa, propDest_ab, timeSeconds, animType, delay, callback, extra1, extra2)
	{
		// Does a color transformation tweening, based on Flash's "advanced" color transformation settings.
		// Works like Flash MX's color.setTransform method, although it uses properties directly as parameters and not a color object
		//  Example: <movieclip>.colorTo(200, 0, 200, 0, 200, 0, undefined, undefined, 2)
		// ra = red alpha, % of the original object's color to remain on the new object
		// rb = red offset, how much to add to the red color
		// ga, gb = same for green
		// ba, bb = same for blue
		// aa, ab = same for alpha
		var $_clrTmp = new Color (clip);
		var $_clrNow = $_clrTmp.getTransform ();
		clip.$_ADVsetter_ra = propDest_ra == undefined ? undefined : $_clrNow.ra;
		// 1.12.9: don't create if undefined (not tweening)
		clip.$_ADVsetter_rb = propDest_rb == undefined ? undefined : $_clrNow.rb;
		clip.$_ADVsetter_ga = propDest_ga == undefined ? undefined : $_clrNow.ga;
		clip.$_ADVsetter_gb = propDest_gb == undefined ? undefined : $_clrNow.gb;
		clip.$_ADVsetter_ba = propDest_ba == undefined ? undefined : $_clrNow.ba;
		clip.$_ADVsetter_bb = propDest_bb == undefined ? undefined : $_clrNow.bb;
		clip.$_ADVsetter_aa = propDest_aa == undefined ? undefined : $_clrNow.aa;
		clip.$_ADVsetter_ab = propDest_ab == undefined ? undefined : $_clrNow.ab;
		clip.$_new_ra = propDest_ra;
		clip.$_new_rb = propDest_rb;
		clip.$_new_ga = propDest_ga;
		clip.$_new_gb = propDest_gb;
		clip.$_new_ba = propDest_ba;
		clip.$_new_bb = propDest_bb;
		clip.$_new_aa = propDest_aa;
		clip.$_new_ab = propDest_ab;
		tween (["$_ADVsetter_ra", "$_ADVsetter_rb", "$_ADVsetter_ga", "$_ADVsetter_gb", "$_ADVsetter_ba", "$_ADVsetter_bb", "$_ADVsetter_aa", "$_ADVsetter_ab"] , [clip.$_new_ra, clip.$_new_rb, clip.$_new_ga, clip.$_new_gb, clip.$_new_ba, clip.$_new_bb, clip.$_new_aa, clip.$_new_ab] , timeSeconds, animType, delay, callback, extra1, extra2);
		clip.__tweenController_ADVhelper__.removeMovieClip ();
		clip.createEmptyMovieClip ("__tweenController_ADVhelper__", 123434);
		clip.__tweenController_ADVhelper__.onEnterFrame = function ()
		{
			var tweenColor = new Color (this._parent);
			// 1.12.9: only adds existing properties :: START
			var ADVToSet = {
			}
			if (this._parent.$_ADVsetter_ra != undefined) ADVToSet.ra = this._parent.$_ADVsetter_ra;
			if (this._parent.$_ADVsetter_rb != undefined) ADVToSet.rb = this._parent.$_ADVsetter_rb;
			if (this._parent.$_ADVsetter_ga != undefined) ADVToSet.ga = this._parent.$_ADVsetter_ga;
			if (this._parent.$_ADVsetter_gb != undefined) ADVToSet.gb = this._parent.$_ADVsetter_gb;
			if (this._parent.$_ADVsetter_ba != undefined) ADVToSet.ba = this._parent.$_ADVsetter_ba;
			if (this._parent.$_ADVsetter_bb != undefined) ADVToSet.bb = this._parent.$_ADVsetter_bb;
			if (this._parent.$_ADVsetter_aa != undefined) ADVToSet.aa = this._parent.$_ADVsetter_aa;
			if (this._parent.$_ADVsetter_ab != undefined) ADVToSet.ab = this._parent.$_ADVsetter_ab;
			// 1.12.9: only adds existing properties :: END
			tweenColor.setTransform (ADVToSet);
			if (this.$_toDelete)
			{
				// These _parent variables were used temporarily as proxy variables
				// So they should be deleted too
				delete this._parent.$_ADVsetter_ra;
				delete this._parent.$_ADVsetter_rb;
				delete this._parent.$_ADVsetter_ga;
				delete this._parent.$_ADVsetter_gb;
				delete this._parent.$_ADVsetter_ba;
				delete this._parent.$_ADVsetter_bb;
				delete this._parent.$_ADVsetter_aa;
				delete this._parent.$_ADVsetter_ab;
				delete this._parent.$_new_ra;
				delete this._parent.$_new_rb;
				delete this._parent.$_new_ga;
				delete this._parent.$_new_gb;
				delete this._parent.$_new_ba;
				delete this._parent.$_new_bb;
				delete this._parent.$_new_aa;
				delete this._parent.$_new_ab;
				this.removeMovieClip ();
			}
			if ((this._parent.$_ADVsetter_ra == this._parent.$_new_ra || this._parent.$_new_ra == undefined) && (this._parent.$_ADVsetter_rb == this._parent.$_new_rb || this._parent.$_new_rb == undefined) && (this._parent.$_ADVsetter_ga == this._parent.$_new_ga || this._parent.$_new_ga == undefined) && (this._parent.$_ADVsetter_gb == this._parent.$_new_gb || this._parent.$_new_gb == undefined) && (this._parent.$_ADVsetter_ba == this._parent.$_new_ba || this._parent.$_new_ba == undefined) && (this._parent.$_ADVsetter_bb == this._parent.$_new_bb || this._parent.$_new_bb == undefined) && (this._parent.$_ADVsetter_aa == this._parent.$_new_aa || this._parent.$_new_aa == undefined) && (this._parent.$_ADVsetter_ab == this._parent.$_new_ab || this._parent.$_new_ab == undefined))
			{
				// Has finished moving, so set this proxy movieclips to be deleted
				// It will only be deleted in the next frame to avoid removing new animations movie clips
				this.$_toDelete = true;
			}
		};
		
	};
	*/
}
